/***********************************************************************
@@Main.cpp

@@Smoke Effect

@@Date : Nov. 02, 2007
@@Version : 1.0
@@Author : Pocol
@@Memo :
*************************************************************************/

//
//@include
//
#include <iostream>
#include <cmath>
#include <GL/glew.h>
#include <GL/glut.h>
#include "Smoke.h"
using namespace std;

//
//@link
//
#pragma comment (lib, "glew32.lib")


//
//@global
//
int WindowPositionX = 100;
int WindowPositionY = 100;
int WindowWidth = 512;
int WindowHeight = 512;
char WindowTitle[] = "@GtFNg@";
GLfloat smokeColor[3] = { 0.2, 0.2, 0.2 };
Smoke smoke(100, smokeColor);

//
//@prototype
//
void Initialize();
void Display();
void Idle();
void Reshape(int x, int y);
void Keyboard(unsigned char key, int x, int y);
void Special(int key, int x, int y);
void Mouse(int button, int state, int x, int y);
void Motion(int x, int y);
void PassiveMotion(int x, int y);


//----------------------------------------------------------------------------------------------------
//@@main
//@@Desc : CGg|Cg
//----------------------------------------------------------------------------------------------------
int main( int argc, char **argv )
{
	glutInit(&argc, argv);
	glutInitWindowPosition(WindowPositionX, WindowPositionY);
	glutInitWindowSize(WindowWidth, WindowHeight);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	glutCreateWindow(WindowTitle);
	glutDisplayFunc(Display);
	glutReshapeFunc(Reshape);
	glutIdleFunc(Idle);
	glutMouseFunc(Mouse);
	glutMotionFunc(Motion);
	glutPassiveMotionFunc(PassiveMotion);
	glutKeyboardFunc(Keyboard);
	glutSpecialFunc(Special);

	Initialize();

	glutMainLoop();

	return 0;
}

//----------------------------------------------------------------------------------------------------
//@@Initialize
//@@Desc : 
//----------------------------------------------------------------------------------------------------
void Initialize()
{
	//@GLEW̏
	if ( glewInit() != GLEW_OK )
	{
		cout << "Error : GLEW̏Ɏs܂\n";
		exit(0);
	}

	//@hԂF
	glClearColor(0.3, 0.3, 1.0, 0.0);

	//@[xeXg
	glEnable(GL_DEPTH_TEST);

	//@X[YVFCfBO
	glShadeModel(GL_SMOOTH);

	//@obNtF[XJO
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);

	smoke.LoadTexture("sample.dds");
	
}

//---------------------------------------------------------------------------------------------------
//@@Idle
//@@Desc : AChȌ
//---------------------------------------------------------------------------------------------------
void Idle()
{
	glutPostRedisplay();
}

//---------------------------------------------------------------------------------------------------
//@@Reshape
//@@Desc : TCYύX
//---------------------------------------------------------------------------------------------------
void Reshape(int x, int y)
{
	WindowWidth = x;
	WindowHeight = y;
	if ( WindowWidth < 1 ) WindowWidth = 1;
	if ( WindowHeight < 1 ) WindowHeight = 1;

	glViewport(0, 0, WindowWidth, WindowHeight);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(50.0, (double)WindowWidth/(double)WindowHeight, 0.1, 1000.0);
}

//---------------------------------------------------------------------------------------------------
//@@Display
//@@Desc : EBhEւ̕`
//---------------------------------------------------------------------------------------------------
void Display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glViewport(0, 0, WindowWidth, WindowHeight);

	glPushMatrix();

	//@_̕`
	gluLookAt(
		0.0, 0.0, -5.0,
		0.0, 0.0, 0.0,
		0.0, 1.0, 1.0 );

	smoke.Move();
	smoke.Render();

	
	glPopMatrix();

	glutSwapBuffers();
}

//---------------------------------------------------------------------------------------------------
//@@Mouse
//@@Desc : }EX
//---------------------------------------------------------------------------------------------------
void Mouse(int button, int state, int x, int y)
{
}

//--------------------------------------------------------------------------------------------------
//@@Motion
//@@Desc : }EXhbO
//--------------------------------------------------------------------------------------------------
void Motion(int x, int y)
{
}

//--------------------------------------------------------------------------------------------------
//@@PassiveMotion
//@@Desc : }EXړ
//--------------------------------------------------------------------------------------------------
void PassiveMotion(int x, int y)
{
}

//--------------------------------------------------------------------------------------------------
//@@Keyboard
//@@Desc : L[{[h
//--------------------------------------------------------------------------------------------------
void Keyboard(unsigned char key, int x, int y)
{
	switch ( key )
	{
	case '\033':
		exit(0);
		break;

	default:
		break;
	}
}

//--------------------------------------------------------------------------------------------------
//@@Special
//@@Desc : L[
//--------------------------------------------------------------------------------------------------
void Special(int key, int x, int y)
{
	switch ( key )
	{
	case GLUT_KEY_F1:
		break;

	case GLUT_KEY_F2:
		break;

	case GLUT_KEY_F3:
		break;

	case GLUT_KEY_F4:
		break;

	case GLUT_KEY_F5:
		break;

	case GLUT_KEY_F6:
		break;

	case GLUT_KEY_F7:
		break;

	case GLUT_KEY_F8:
		break;

	case GLUT_KEY_F9:
		break;

	case GLUT_KEY_F10:
		break;

	case GLUT_KEY_F11:
		break;

	case GLUT_KEY_F12:
		break;

	case GLUT_KEY_LEFT:
		break;

	case GLUT_KEY_RIGHT:
		break;

	case GLUT_KEY_UP:
		break;

	case GLUT_KEY_DOWN:
		break;

	case GLUT_KEY_PAGE_UP:
		break;

	case GLUT_KEY_PAGE_DOWN:
		break;

	case GLUT_KEY_HOME:
		break;

	case GLUT_KEY_END:
		break;

	case GLUT_KEY_INSERT:
		break;
	}
}
