/************************************************************************
@@Smoke.h

@@Smoke Effect

@@Date : Nov. 12, 2007
@@Version : 1.0
@@Author : Pocol
*************************************************************************/

#ifndef _SMOKE_H_INCLUDED_
#define _SMOKE_H_INCLUDED_

//
//@include
//
#include <iostream>
#include <cmath>
#include <GL/glew.h>
#include <GL/glut.h>
#include "DDSLoader.h"
using namespace std;

//
//@link
//
#pragma comment(lib, "glew32.lib")

/////////////////////////////////////////////////////////////////////////
//@@SmokeParticle class
/////////////////////////////////////////////////////////////////////////
class SmokeParticle
{
protected:
	double position[3];
	double velocity[3];
	double size;
	float color[3];
	float baseColor[3];

	int time;
	int endTime;

public:
	SmokeParticle(float base_color[3]);
	~SmokeParticle();
	void Initialize();
	void Move();
	void Render();
};

/////////////////////////////////////////////////////////////////////////
//@@Smoke class
/////////////////////////////////////////////////////////////////////////
class Smoke
{
protected:
	SmokeParticle **smokeparticle;
	int smokeCount;
	DDSImage texture;

public:
	Smoke(int smoke_count, float smoke_color[3]);
	~Smoke();
	void LoadTexture(const char *filename);
	void Move();
	void Render();
};

#endif	//@_SMOKE_H_INCLUDED_